using System;
using System.Data;
using ShopClassLibrary;

namespace TestShopConsole
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class Class1
	{
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
//			User u = new User();
//			ShopStatusEnum status = u.Validate("joao", "joao");


			TesteGetCustomer();


//			TestAddCustomer();


//			TesteAddSale();


			//
			// testes de stress para verificar concorrencia e integridade dos dados
			// para expriemntar correr o executavle a partir da linha de comando em mais
			// que uma janela
			//
//			TesteStressAdd_1();
//			TesteStressAdd_2();


			Console.WriteLine("\n\nQQ tecla para continuar...");
			Console.ReadLine();
		}

		public static void TesteStressAdd_1()
		{
			System.Diagnostics.Process x = System.Diagnostics.Process.GetCurrentProcess();

			int prod = 8;

			ShopStatus s;
			// IProduct p = new Product();
			IProduct p = Factory.CreateProductService();

			System.Console.WriteLine("Tester#{0} : stock inicial = {1} status={2}", x.Id, p.GetStock("joao", "joao", prod, out s), s);

			for (int n = 0; n < 50; n++)
			{
				s = p.AddStock("joao", "joao", prod, 1);
				if (s != ShopStatus.Ok)
					System.Console.WriteLine("Tester#{0} : ERRO ciclo {1} status={2}", x.Id, n, s);
			}

			System.Console.WriteLine("Tester#{0} : stock final = {1} status={2}", x.Id, p.GetStock("joao", "joao", prod, out s), s);
		}

		public static void TesteStressAdd_2()
		{
			System.Diagnostics.Process x = System.Diagnostics.Process.GetCurrentProcess();

			int prod = 8;
			int n = 20;
			int[] cust = new int[] {31, 32, 33};

			ShopStatus st;
			// IProduct p = new Product();
			IProduct p = Factory.CreateProductService();

			st = p.AddStock("joao", "joao", prod, 50);
			System.Console.WriteLine("Tester#{0} : adicionar {1} unidades de stock ao produto {2} status={3}", x.Id, n, prod, st);

			// ISale c = new Sale();
			ISale s = Factory.CreateSaleService();

			for (int i = 0; i < n; i++)
			{
				DataSet ds = s.CreateDetails("joao", "joao");

				DataRow dr = ds.Tables["SaleDetails"].NewRow();
				dr["productid"] = prod;
				dr["quantity"] = 1;
				ds.Tables["SaleDetails"].Rows.Add(dr);

				st = s.Add("joao", "joao", cust[i % cust.Length], DateTime.Now, ds);
				if (st != ShopStatus.Ok)
					System.Console.WriteLine("Tester#{0} : ERRO ciclo {1} status={2}", x.Id, i, st);
			}

			System.Console.WriteLine("Tester#{0} : stock final = {1} status={2}", x, p.GetStock("joao", "joao", prod, out st), st);
		}

		public static void TesteGetCustomer()
		{
			// ICustomer c = new Customer();
			ICustomer c = Factory.CreateCustomerService();

			DataSet oDS = c.GetById("joao", "joao", 27);
			DataSet ds1 = c.FindByName("joao", "joao", "cli");

			foreach(DataRow myRow in oDS.Tables["Customers"].Rows)
			{
				Console.WriteLine(myRow["Name"]);

				//foreach(DataColumn myCol in oDT.Columns)
				//{
				//	Console.WriteLine(myRow[myCol]);
				//}
			}
		}

		public static void TestAddCustomer()
		{
			Console.WriteLine("TESTE 'Customer' -->\n\n");

			//
			// criar objecto
			//
			// ICustomer oCust = new Customer();
			ICustomer oCust = Factory.CreateCustomerService();

			//
			// invocar mtodo
			//
			ShopStatus status;
			long custID;
			custID = oCust.Add("joao", "joao", "outro cliente", "outra morada", "telefone", "fax", "email", out status);

			Console.WriteLine("Customer.AddCustomer: status={0}, CustomerID={1}\n", status, custID);		
		}

		public static void TesteAddSale()
		{
			// ISale c = new Sale();
			ISale s = Factory.CreateSaleService();

			DataSet ds = s.CreateDetails("joao", "joao");

			DataRow dr = ds.Tables["SaleDetails"].NewRow();
			dr["productid"] = 8;
			dr["quantity"] = 3;
			ds.Tables["SaleDetails"].Rows.Add(dr);

			dr = ds.Tables["SaleDetails"].NewRow();
			dr["productid"] = 9;
			dr["quantity"] = 10;
			ds.Tables["SaleDetails"].Rows.Add(dr);

			//ds.AcceptChanges();

			ShopStatus status = s.Add("joao", "joao", 27, DateTime.Now, ds);

			Console.WriteLine("Sale.AddSale: status={0}\n", status);		
		}
	}
}
